/* gamemain2.c */
#include<scenario.h>
#include<screen.h>
#include<gameio.h>
#include<walls.h>
#include<stdio.h>
#include<myenemy.h>       //
#include<enemyrika.h>     //
#include<enemy_yuriko.h>  //
#include<movingobjectmanager.h>
#include <curses.h>       //
#ifdef DEBUG
#include<log.h>
#endif

#define OBJNUM 2   
#define MOBJNUM 8    //敵の種類+2
#define EVNUM 23     //敵の数

object* objp[OBJNUM];
movingobject* mobjp[MOBJNUM];
event* ev[EVNUM];
vector2 mypos;
int isfire;
int score;
static int game = 0;

void onestepb(movingobject* mobj){
  vec2add(&(mobj->pos), &(mobj->vel));
}

void dispb(movingobject* mobj){
  putobject(*(mobj->obj), mobj->id, mobj->pos.x, mobj->pos.y);
}

void dispm(movingobject* mobj){
  putobject(*(mobj->obj), 0, mobj->pos.x, mobj->pos.y);
}

int bomba(movingobject* mobj){
  return 1;
}

void initobjects(void){
  objp[0] = newobject(1,1,"x");
  objp[1] = newobject(3,2," ^ =x=");
}

void initmovingobjects(void){
  mobjp[0] = newenemy1();       //敵1:クラゲ
  mobjp[1] = newmovingobject(&objp[0], onestepb, dispb, bomba, "bullet");   //弾
  mobjp[2] = newmovingobject(&objp[1], NULL, dispm, bomba, "me");           //自分
  mobjp[3] = newenemy2();       //敵2:魚
  mobjp[4] = newenemy3();       //敵3:boss
  mobjp[5] = newenemy4();        //りかちゃんが作った敵
  mobjp[6] = originalenemy1();  //ゆりこちゃん１
  mobjp[7] = originalenemy2();  //2
}

void setevents(void){
  int i;
  for(i=0; i<4; i++){
    ev[5*i+0] = newevent(50*i+ 5, makevector2(25,7),makevector2(0.1, 0), mobjp[3],"plus0");
    ev[5*i+1] = newevent(50*i+10, makevector2(30,2),makevector2(0.1, 0), mobjp[5],"plus1");
    ev[5*i+2] = newevent(50*i+25, makevector2(20,5),makevector2(0.05 ,0.1),   mobjp[0],"plus2");
    ev[5*i+3] = newevent(50*i+30, makevector2(30,9),makevector2(0.1, 0), mobjp[6],"plus3");
    ev[5*i+4] = newevent(50*i+40, makevector2(20,13),makevector2(0.1, 0), mobjp[7],"plus4");
  }
  ev[19] = newevent(50*i+35, makevector2(9,7), makevector2(-0.1, 0.1), mobjp[4], "boss");
  ev[20] = newevent(50*i+65, makevector2(22,6),makevector2(0.1,0.05),mobjp[4], "boss");
  ev[21] = newevent(50*i+100, makevector2(8,5), makevector2(-0.1, 0.1), mobjp[4], "boss");
  ev[22] = newevent(1000000, 
                   makevector2(30,1),makevector2(0,1), mobjp[0],"dummy");
  for(i=0;i<EVNUM;i++){
    addevent(ev[i]);
  }
  resetmark();
}

void init(void){
  initscreen();
  initwalls();
  initmom();
  initobjects();
  initmovingobjects();
  initscenario();
  setevents();
}


void getstate(vector2* ret, int* isfire){
  static vector2 pos = {SCREENWIDTH/2-1, SCREENHEIGHT-3}; 
  *isfire = 0;
  int in = gameioread();
  switch(in){
    //  case 'f':
    //  case 'F':
  case 'C':       //→(^[[C)
    pos.x++;
    break;
    //  case 'b':
    //  case 'B':
  case 'D':       //←(^[[D)
    pos.x--;
    break;
    //  case 'p':
    //  case 'P':
  case 'A':       //↑(^[[A)
    pos.y--;
    break;
    //  case 'n':
    //  case 'N':
  case 'B':       //↓(^[[B)
    pos.y++;
    break;
  case ' ':
    *isfire = 1;
  } 
  *ret = pos;
}

void show(void){
  int x,y;
  for(y=0;y<SCREENHEIGHT;y++){
    for(x=0;x<SCREENWIDTH;x++){
      gameioput(x,y,dispbuffer[SCREENWIDTH*y+x]);
    }
  }
  gameiorefresh();
}

void gameloop(void){
  int speedlevel = 18;       //始めの周期を0.03^speedlevel(18)秒に
  int time=0;
  vector2 tmpv;
  vector2 eattack[3];
  int i=0;
  event* e = getnextevent();
  int hp = 6;
  game = 0;
  while(time <2500){
    gameiousleep(30000);
    if(time%speedlevel == 0){
      scrollwall();
      while(e!= NULL && e->time*speedlevel < time){
	addmo(e->mobj, e->pos, e->vel);
	for(i=0; i<3; i++){
	  eattack[i] = e->pos;         //敵も攻撃
	  eattack[i].x +=1;            //
	  eattack[i].y +=9 +i*3;       //
	  addmo(mobjp[1], eattack[i], makevector2(0,0.5));   //
	} 
	e = getnextevent();
      }
      score++;
    }
    getstate(&mypos, &isfire);
    gameioput(SCREENWIDTH+3,1,'0'+(int)mypos.x/10);
    gameioput(SCREENWIDTH+4,1,'0'+(int)mypos.x%10);
    gameioput(SCREENWIDTH+6,1,'0'+(int)mypos.y/10);
    gameioput(SCREENWIDTH+7,1,'0'+(int)mypos.y%10);
    mvprintw(2,SCREENWIDTH+3,"SCORE:%d",score);        //scoreを表示
    mvprintw(3,SCREENWIDTH+3,"HP:%d",hp/2);            //HPを表示
    mvprintw(4,SCREENWIDTH+3,"GOAL:%d",500-time/5);    //time
    putwalls(SCREENHEIGHT);
    putmo(&score);
    onestepmo();
    if(checkcollision(mypos, objp[1])!= NONOBJ){
      hp--; 
      if(hp == 0){
	game = 0;
	break;  
      }
    }
    if(checkcollision(mypos, objp[1]) == WALL){   //壁にぶつかったら死
      game = 0;
      break;
    }
    if(isfire){
      tmpv = mypos;
      tmpv.x +=1;
      tmpv.y -=2;
      addmo(mobjp[1], tmpv, makevector2(0,-1));
    }
    mobjp[2]->pos = mypos;
    dispm(mobjp[2]);
    show();
    time++;
    if(time%200 == 0 && speedlevel >= 2){    //0.03*200=6秒ごとに周期を小さく =スピードを速く
      speedlevel--;
    }
  }
  if(time >=2500){
    game = 1;  //time=2500 --ゲームクリア
  }
}  

int main(void){
  char ch;

  gameioinit();
  gameioclear();
  init();

  mvprintw(SCREENHEIGHT/2+2, SCREENWIDTH/2-11, "//////////////////////");
  mvprintw(SCREENHEIGHT/2+1, SCREENWIDTH/2-11, "//                  //");
  mvprintw(SCREENHEIGHT/2,   SCREENWIDTH/2-11, "//       START      //");     //スタート画面を表示
  mvprintw(SCREENHEIGHT/2-1, SCREENWIDTH/2-11, "//                  //");
  mvprintw(SCREENHEIGHT/2-2, SCREENWIDTH/2-11, "//////////////////////");
  while(1){                                                    //スペースキーを押してゲームスタート
    ch = getch();
    if(ch == ' '){
      break;
    }
  }
  gameioclear();
  
  score=0;
  gameloop();

  gameioclear();                                                  //画面をクリアして
  mvprintw(SCREENHEIGHT/2-1, SCREENWIDTH/2-11, "///////////////////////");
  if(game == 0){
    mvprintw(SCREENHEIGHT/2, SCREENWIDTH/2-11, "//    GAME  OVER     //");         //ゲームオーバーの表示
  }else if(game == 1){
    mvprintw(SCREENHEIGHT/2, SCREENWIDTH/2-11, "//    GAME  CLEAR!   //");         //ゲームクリアの表示
  } 
  mvprintw(SCREENHEIGHT/2+1, SCREENWIDTH/2-11, "//    SCORE: %4d    //", score);//スコアを表示
  mvprintw(SCREENHEIGHT/2+2, SCREENWIDTH/2-11, "///////////////////////");
  while(1){
    ch = getch();                                                 //スペースキーで終了
    if(ch == ' '){
      break;
    }
  }
  gameiopost();
  printf("score %d\n",score);

  return 0;
}
